<?php
/*
Plugin Name: Paid Member Subscriptions - Exclude Restricted Posts From Query
Plugin URI: http://www.cozmoslabs.com
Description: Exclude restricted posts and pages from the main queries like blog, archive and taxonomy pages. It does not exclude them from custom queries.
Author: Cristian Antohe
Version: 1.0
Author URI: http://www.cozmoslabs.com
*/

add_action( 'pre_get_posts', 'pmsc_exclude_post_from_query', 40 );
function pmsc_exclude_post_from_query( $query ) {

    if( !function_exists( 'pms_is_post_restricted' ) || is_admin() || is_single() )
        return;

    if( $query->is_main_query() || ( $query->is_search() && isset( $_GET['s'] ) ) ) {
        
        remove_action('pre_get_posts', 'pmsc_exclude_post_from_query', 40 );
            
        $args = $query->query_vars;
        $args['suppress_filters'] = true;
        $args['posts_per_page'] = get_option( 'posts_per_page' );
        $posts = get_posts($args);

        $ids = wp_list_pluck( $posts, 'ID' );
        $restricted_ids = array_filter($ids,'pms_is_post_restricted');

        $query->set( 'post__not_in', $restricted_ids );
    }
}
